package sd201311.handwriting.View;

import java.util.ArrayList;

import sd201311.handwriting.R;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;

public class DrawView extends View {
	// Canvas`p
	Paint mCnvsPaint = new Paint();
	// `F
	private int mDrawColor = Color.WHITE;
	// `̕
	private int mStrokeWidth = 5;

	// `ʒu
	ArrayList<Point> mDrawPoint = new ArrayList<Point>();
    
	/**
	 * RXgN^
	 *
	 * @param context
	 * @param attrs
	 */
	public DrawView(Context context, AttributeSet attrs) {
		super(context, attrs);
		// attrs.xmlɒ`X^C
		TypedArray drawAt 
			= context.obtainStyledAttributes(attrs, R.styleable.DrawViewAttr);
		// `F̐ݒBcolorɒ`l擾
		mDrawColor = drawAt.getColor(0, Color.WHITE);
		// `̐̕ݒBstroke_widthɒ`l擾
		mStrokeWidth = drawAt.getInt(1, 5);
		// svȂ̂Ŕj
		drawAt.recycle();
		
		// Canvas`̐ݒ
		// A`GCAXLɂ
		mCnvsPaint.setAntiAlias(true);
		// F̐ݒ
		mCnvsPaint.setColor(mDrawColor);
		// `̐̕ݒ
		mCnvsPaint.setStrokeWidth(mStrokeWidth);
		// `X^ChԂ[hŐݒ
		mCnvsPaint.setStyle(Paint.Style.FILL);
	}

	/**
	 * `揈
	 *
	 * @param canvas canvas
	 */
	@SuppressLint("DrawAllocation")
	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		
		Point back = new Point(-1, -1);
		// `悷
		for(Point item : mDrawPoint){
			if (item.x >= 0) {
				if (back.x < 0) {
					back = item;
				}
				// _Ɠ_𒼐ŌсAAĂ悤Ɍ
				canvas.drawLine(back.x, back.y, item.x, item.y, mCnvsPaint);
				
				int circle = mStrokeWidth/2;
				// _͉~`悷邱ƂŊ炩ȐɌ
				canvas.drawCircle(item.x, item.y, circle, mCnvsPaint);
			}
			back = item;
		}
	}
	
	/**
	 * ^b`Cxg
	 *
	 * @param event event
	 * @return 
	 */
	@Override
	public boolean onTouchEvent(MotionEvent event) {
		// ^b`Wi[
		mDrawPoint.add(new Point((int)event.getX(),(int)event.getY()));
		
		// ^b`~߂ꍇ(ʂ痣ꍇ)
		if (event.getAction() == MotionEvent.ACTION_UP) {
			mDrawPoint.add(new Point(-1, -1));
		}
		
		// ĕ`
		invalidate();
		return true;
	}
}
